import Support as sp
import numpy as np

def get_level2Instance_by_LV4Instance(lv4_instances, conn):
    #initialize array
    #lv4_Lv2_map = np.array([], dtype=[('lv4', int),('lv2',int), ('data', float)])
    #fill array
    cur = conn.cursor()
    # #lv4_instances=np.array(lv4_instances,dtype=[('keys', int), ('data', float)])
    #create and execute lv2 query
    liststring = sp.list_to_string(lv4_instances)
    query = "select i.called_by from instances i where i.instance in (select called_by from instances i where i.instance in(" + liststring + "))"
    cur.execute(query)
    sqlResult = cur.fetchall()
    lv2_instances = np.array([], dtype=int)
    for entry in sqlResult:
        lv2_instance = np.array(int(entry[0]), dtype = lv2_instances.dtype)
        lv2_instances=np.append(lv2_instances,lv2_instance)
    # print(query)
    #print("LV2")
    #print(lv2_instances)
    return lv2_instances


def orderLV2InstancesChronoligically(lv2_instances, conn):
    cur = conn.cursor()
    liststring = sp.list_to_string(lv2_instances)
    query = "select distinct instance from logEntries where instance in (" + liststring + ") order by timestamp asc"
    #print(query)
    cur.execute(query)
    sqlResult = cur.fetchall()
    lv2_instances = np.array([], dtype=int)
    for entry in sqlResult:
        lv2_instances = np.append(lv2_instances, np.array([int(entry[0])], dtype=lv2_instances.dtype))
    #print("lv2_Sorted")
    #print(lv2_instances)
    return lv2_instances
