import Support as sp
import numpy as np

def get_part_by_lv2Instance(lv2_instances, condition, conn):
    switchCase = {"all":"", "nok":" and status = 'nok' ", "ok": " and status = 'ok' "}
    condition = switchCase[condition]
    #initialize array
    #lv4_Lv2_map = np.array([], dtype=[('lv4', int),('lv2',int), ('data', float)])
    #fill array
    cur = conn.cursor()
    # #lv4_instances=np.array(lv4_instances,dtype=[('keys', int), ('data', float)])
    #create and execute lv2 query
    liststring = sp.list_to_string(lv2_instances)
    query = "select distinct mt.part from measureTot mt join instances i on mt.instance=i.instance where i.instance in (" + liststring + ")" + condition
    #print(query)
    cur.execute(query)
    sqlResult = cur.fetchall()
    parts = np.array([], dtype=int)
    for entry in sqlResult:
        part = np.array(int(entry[0]), dtype = parts.dtype)
        parts = np.append(parts,part)
    # print(query)
    #print("parts")
    #print(parts)
    return parts


def orderPartsChronoligically(parts, conn):
    cur = conn.cursor()
    liststring = sp.list_to_string(parts)
    query = "select distinct mt.part from measureTot mt join instances i on i.instance=mt.instance join logEntries log on log.instance=i.instance where mt.part in (" + liststring + ") order by log.timestamp asc"
    #print(query)
    cur.execute(query)
    sqlResult = cur.fetchall()
    parts = np.array([], dtype=int)
    for entry in sqlResult:
        parts = np.append(parts, np.array([int(entry[0])], dtype=parts.dtype))
    #print("parts_Sorted")
    #print(parts)
    return parts
